Loading...
Searching...
No Matches
CacheItem< TreeCacheT, NodeVecT, true, false > Class Template Reference

The tail of a compile-time list of cached node pointers, ordered from LeafNode to RootNode. More...

`#include <openvdb/tree/ValueAccessor.h>`

## Public Types

using | RootNodeType = typename NodeVecT::Front
using | ValueType = typename RootNodeType::ValueType
using | LeafNodeType = typename RootNodeType::LeafNodeType
using | NodeType
using | CoordLimits

## Public Member Functions

| CacheItem (TreeCacheT &parent)
| CacheItem (TreeCacheT &parent, const CacheItem &other)
CacheItem & | copy (TreeCacheT &parent, const CacheItem &other)
bool | isCached (const Coord &xyz) const
void | insert (const Coord &, const RootNodeType *root)
template<typename OtherNodeType>
void | insert (const Coord &, const OtherNodeType *)
void | erase (const RootNodeType *)
void | clear ()
void | getNode (RootNodeType *&node)
void | getNode (const RootNodeType *&node) const
void | addLeaf (LeafNodeType *leaf)
void | addTile (Index level, const Coord &xyz, const ValueType &value, bool state)
LeafNodeType * | touchLeaf (const Coord &xyz)
LeafNodeType * | probeLeaf (const Coord &xyz)
const LeafNodeType * | probeConstLeaf (const Coord &xyz)
template<typename NodeType>
NodeType * | probeNode (const Coord &xyz)
template<typename NodeType>
const NodeType * | probeConstNode (const Coord &xyz)
int | getValueDepth (const Coord &xyz)
bool | isValueOn (const Coord &xyz)
bool | probeValue (const Coord &xyz, ValueType &value)
bool | isVoxel (const Coord &xyz)
const ValueType & | getValue (const Coord &xyz)
void | setValue (const Coord &xyz, const ValueType &value)
void | setValueOnly (const Coord &xyz, const ValueType &value)
void | setValueOn (const Coord &xyz, const ValueType &value)
template<typename ModifyOp>
void | modifyValue (const Coord &xyz, const ModifyOp &op)
template<typename ModifyOp>
void | modifyValueAndActiveState (const Coord &xyz, const ModifyOp &op)
void | setValueOff (const Coord &xyz, const ValueType &value)
void | setActiveState (const Coord &xyz, bool on)

## Detailed Description

template<typename TreeCacheT, typename NodeVecT>
class openvdb::v10_0::tree::CacheItem< TreeCacheT, NodeVecT, true, false >

The tail of a compile-time list of cached node pointers, ordered from LeafNode to RootNode.

## Member Typedef Documentation

## CoordLimits

using CoordLimits

## LeafNodeType

template<typename TreeCacheT, typename NodeVecT>

using LeafNodeType = typename RootNodeType::LeafNodeType

## NodeType

using NodeType

## RootNodeType

template<typename TreeCacheT, typename NodeVecT>

using RootNodeType = typename NodeVecT::Front

## ValueType

template<typename TreeCacheT, typename NodeVecT>

using ValueType = typename RootNodeType::ValueType

## Constructor & Destructor Documentation

## CacheItem() [1/2]

template<typename TreeCacheT, typename NodeVecT>

CacheItem | ( | TreeCacheT & | parent | ) |

inline

## CacheItem() [2/2]

template<typename TreeCacheT, typename NodeVecT>

CacheItem | ( | TreeCacheT & | parent,
|  | const CacheItem< TreeCacheT, NodeVecT, true, false > & | other )

inline

## Member Function Documentation

## addLeaf()

template<typename TreeCacheT, typename NodeVecT>

void addLeaf | ( | LeafNodeType * | leaf | ) |

inline

## addTile()

template<typename TreeCacheT, typename NodeVecT>

void addTile | ( | Index | level,
|  | const Coord & | xyz,
|  | const ValueType & | value,
|  | bool | state )

inline

## clear()

template<typename TreeCacheT, typename NodeVecT>

void clear | ( |  | ) |

inline

## copy()

template<typename TreeCacheT, typename NodeVecT>

CacheItem & copy | ( | TreeCacheT & | parent,
|  | const CacheItem< TreeCacheT, NodeVecT, true, false > & | other )

inline

## erase()

template<typename TreeCacheT, typename NodeVecT>

void erase | ( | const RootNodeType * |  | ) |

inline

## getNode() [1/2]

template<typename TreeCacheT, typename NodeVecT>

void getNode | ( | const RootNodeType *& | node | ) | const

inline

## getNode() [2/2]

template<typename TreeCacheT, typename NodeVecT>

void getNode | ( | RootNodeType *& | node | ) |

inline

## getValue()

template<typename TreeCacheT, typename NodeVecT>

const ValueType & getValue | ( | const Coord & | xyz | ) |

inline

## getValueDepth()

template<typename TreeCacheT, typename NodeVecT>

int getValueDepth | ( | const Coord & | xyz | ) |

inline

## insert() [1/2]

template<typename TreeCacheT, typename NodeVecT>
template<typename OtherNodeType>

void insert | ( | const Coord & | ,
|  | const OtherNodeType * | )

inline

## insert() [2/2]

template<typename TreeCacheT, typename NodeVecT>

void insert | ( | const Coord & | ,
|  | const RootNodeType * | root )

inline

## isCached()

template<typename TreeCacheT, typename NodeVecT>

bool isCached | ( | const Coord & | xyz | ) | const

inline

## isValueOn()

template<typename TreeCacheT, typename NodeVecT>

bool isValueOn | ( | const Coord & | xyz | ) |

inline

## isVoxel()

template<typename TreeCacheT, typename NodeVecT>

bool isVoxel | ( | const Coord & | xyz | ) |

inline

## modifyValue()

template<typename TreeCacheT, typename NodeVecT>
template<typename ModifyOp>

void modifyValue | ( | const Coord & | xyz,
|  | const ModifyOp & | op )

inline

## modifyValueAndActiveState()

template<typename TreeCacheT, typename NodeVecT>
template<typename ModifyOp>

void modifyValueAndActiveState | ( | const Coord & | xyz,
|  | const ModifyOp & | op )

inline

## probeConstLeaf()

template<typename TreeCacheT, typename NodeVecT>

const LeafNodeType * probeConstLeaf | ( | const Coord & | xyz | ) |

inline

## probeConstNode()

template<typename TreeCacheT, typename NodeVecT>
template<typename NodeType>

const NodeType * probeConstNode | ( | const Coord & | xyz | ) |

inline

## probeLeaf()

template<typename TreeCacheT, typename NodeVecT>

LeafNodeType * probeLeaf | ( | const Coord & | xyz | ) |

inline

## probeNode()

template<typename TreeCacheT, typename NodeVecT>
template<typename NodeType>

NodeType * probeNode | ( | const Coord & | xyz | ) |

inline

## probeValue()

template<typename TreeCacheT, typename NodeVecT>

bool probeValue | ( | const Coord & | xyz,
|  | ValueType & | value )

inline

## setActiveState()

template<typename TreeCacheT, typename NodeVecT>

void setActiveState | ( | const Coord & | xyz,
|  | bool | on )

inline

## setValue()

template<typename TreeCacheT, typename NodeVecT>

void setValue | ( | const Coord & | xyz,
|  | const ValueType & | value )

inline

## setValueOff()

template<typename TreeCacheT, typename NodeVecT>

void setValueOff | ( | const Coord & | xyz,
|  | const ValueType & | value )

inline

## setValueOn()

template<typename TreeCacheT, typename NodeVecT>

void setValueOn | ( | const Coord & | xyz,
|  | const ValueType & | value )

inline

## setValueOnly()

template<typename TreeCacheT, typename NodeVecT>

void setValueOnly | ( | const Coord & | xyz,
|  | const ValueType & | value )

inline

## touchLeaf()

template<typename TreeCacheT, typename NodeVecT>

LeafNodeType * touchLeaf | ( | const Coord & | xyz | ) |

inline